import { JsonObject } from 'type-fest';
export { JsonObject } from 'type-fest';
declare type BaseDocumentObject<ResourceObjectType> = {
    data: ResourceObjectType | ResourceObjectType[] | null;
    meta?: MetaObject;
    included?: ExistingResourceObject[];
};
export declare type ExistingDocumentObject = BaseDocumentObject<ExistingResourceObject>;
export declare type NewDocumentObject = BaseDocumentObject<NewResourceObject>;
export declare type DocumentObject = ExistingDocumentObject | NewDocumentObject;
export declare type AttributesObject = JsonObject;
export declare type MetaObject = JsonObject;
export declare type ResourceIdentifierObject = {
    type: string;
    id: string;
};
export declare type ExistingResourceObject = ResourceIdentifierObject & {
    id: string;
    attributes: AttributesObject;
    relationships?: Record<string, RelationshipObject>;
};
export declare type NewResourceObject = Omit<ExistingResourceObject, 'id'>;
export declare type ResourceObject = ExistingResourceObject | NewResourceObject;
export declare type RelationshipObject = {
    data: ResourceIdentifierObject | ResourceIdentifierObject[];
};
export declare enum CaseType {
    camelCase = "camelCase",
    snakeCase = "snakeCase",
    kebabCase = "kebabCase"
}
export declare type Options<TExtraOptions = void> = {
    idKey?: string;
    fields?: Record<string, string[]>;
    changeCase?: CaseType;
    extra?: TExtraOptions;
};
export declare type SerializeOptions<TExtraOptions = void> = Options<TExtraOptions> & {
    relationships?: string[];
};
